## magma 2.6.2

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.1 )

# ----------------------------------------
# to disable Fortran, set this to "off"
# see also -DADD_ below
option( USE_FORTRAN "Fortran is required for some tester checks, but can be disabled with reduced functionality" ON )

if (USE_FORTRAN)
    project( MAGMA C CXX Fortran )
else()
    project( MAGMA C CXX )
endif()


# ----------------------------------------
# to show compile commands, set this here or use 'make VERBOSE=1'
#set(CMAKE_VERBOSE_MAKEFILE on)

# ----------------------------------------
# MAGMA requires one backend to be enabled
option(MAGMA_ENABLE_CUDA     "Enable the CUDA backend"  OFF)
option(MAGMA_ENABLE_HIP      "Enable the HIP  backend"  OFF)

# check if one backend has been enabled
if (NOT MAGMA_ENABLE_CUDA AND
    NOT MAGMA_ENABLE_HIP
    )
  message(STATUS "MAGMA requires one enabled backend!")
  message(STATUS "Building CUDA backend")
  set( MAGMA_ENABLE_CUDA ON )
endif()

# ----------------------------------------
# don't regenerate files during make.
# (I think this means you have to manually re-run CMake if CMakeLists changes.
# It fixes the huge problems with CMake interrupting Visual Studio.)
set(CMAKE_SUPPRESS_REGENERATION on)


# ----------------------------------------
# force an out-of-source build, to not overwrite the existing Makefiles
# (out-of-source is cleaner, too)
string( COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" MAGMA_COMPILE_INPLACE )
if (MAGMA_COMPILE_INPLACE)
    message( FATAL_ERROR "Compiling MAGMA with CMake requires an out-of-source build. To proceed:
    rm -rf CMakeCache.txt CMakeFiles/   # delete files in ${CMAKE_SOURCE_DIR}
    mkdir build
    cd build
    cmake ..
    make" )
endif()


# ----------------------------------------
# prefer shared libraries
option( BUILD_SHARED_LIBS "If on, build shared libraries, otherwise build static libraries" ON )

# prefer /usr/local/magma, instead of /usr/local.
if (UNIX AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX "/usr/local/magma" CACHE PATH "..." FORCE)
endif()

# ----------------------------------------
# use C++11 and C99
# see http://stackoverflow.com/questions/10851247/how-to-activate-c-11-in-cmake
include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if (COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
    message( WARNING "The compiler ${CMAKE_CXX_COMPILER} doesn't support the -std=c++11 flag. Some code may not compile.")
endif()

CHECK_C_COMPILER_FLAG("-std=c99" COMPILER_SUPPORTS_C99)
if (COMPILER_SUPPORTS_C99)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
else()
    message( WARNING "The compiler ${CMAKE_C_COMPILER} doesn't support the -std=c99 flag. Some code may not compile.")
endif()


# ----------------------------------------
# check Fortran name mangling
if (USE_FORTRAN)
    include( FortranCInterface )
    FortranCInterface_HEADER( ${CMAKE_SOURCE_DIR}/include/magma_mangling_cmake.h MACRO_NAMESPACE MAGMA_ )
else()
    # set one of -DADD_, -DUPCASE, or -DNOCHANGE. See README.
    message( STATUS "Building without Fortran compiler" )
    set( FORTRAN_CONVENTION "-DADD_" CACHE STRING "Fortran calling convention, one of -DADD_, -DNOCHANGE, -DUPCASE" )
    set_property( CACHE FORTRAN_CONVENTION PROPERTY STRINGS -DADD_ -DNOCHANGE -DUPCASE )
    message( STATUS "    Using ${FORTRAN_CONVENTION} for Fortran calling convention" )
    set( CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   ${FORTRAN_CONVENTION}" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FORTRAN_CONVENTION}" )
    # see also NVCC_FLAGS below
endif()


# ----------------------------------------
# locate OpenMP
find_package( OpenMP )
if (OPENMP_FOUND)
    message( STATUS "Found OpenMP" )
    message( STATUS "    OpenMP_C_FLAGS   ${OpenMP_C_FLAGS}" )
    message( STATUS "    OpenMP_CXX_FLAGS ${OpenMP_CXX_FLAGS}" )
    set( CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
endif()

if (MAGMA_ENABLE_CUDA)
  # ----------------------------------------
  # locate CUDA libraries
  set( GPU_TARGET "Kepler Maxwell Pascal" CACHE STRING "CUDA architectures to compile for; one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]" )
  find_package( CUDA )
  if (CUDA_FOUND)
    message( STATUS "Found CUDA ${CUDA_VERSION}" )
    message( STATUS "    CUDA_INCLUDE_DIRS:   ${CUDA_INCLUDE_DIRS}"   )
    message( STATUS "    CUDA_CUDART_LIBRARY: ${CUDA_CUDART_LIBRARY}" )
    #message( STATUS "    CUDA_LIBRARIES: ${CUDA_LIBRARIES}" )
    #message( STATUS "    CUDA_CUBLAS_LIBRARIES: ${CUDA_CUBLAS_LIBRARIES}" )
    include_directories( ${CUDA_INCLUDE_DIRS} )

    # NVCC options for the different cards
    # sm_xx is binary, compute_xx is PTX for forward compatability
    # MIN_ARCH is lowest requested version
    # NV_SM    accumulates sm_xx for all requested versions
    # NV_COMP  is compute_xx for highest requested version
    set( NV_SM    "" )
    set( NV_COMP  "" )

    set(CUDA_SEPARABLE_COMPILATION ON)

    # nvcc >= 6.5 supports -std=c++11, so propagate CXXFLAGS to NVCCFLAGS.
    # Older nvcc didn't support -std=c++11, so previously we disabled propagation.
    ##if (${CMAKE_CXX_FLAGS} MATCHES -std=)
    ##    set( CUDA_PROPAGATE_HOST_FLAGS OFF )
    ##endif()

    if (GPU_TARGET MATCHES Fermi)
        set( GPU_TARGET "${GPU_TARGET} sm_20" )
    endif()

    if (GPU_TARGET MATCHES Kepler)
        set( GPU_TARGET "${GPU_TARGET} sm_30 sm_35 sm_37" )
    endif()

    if (GPU_TARGET MATCHES Maxwell)
        set( GPU_TARGET "${GPU_TARGET} sm_50" )
    endif()

    if (GPU_TARGET MATCHES Pascal)
        set( GPU_TARGET "${GPU_TARGET} sm_60" )
    endif()

    if (GPU_TARGET MATCHES Volta)
        set( GPU_TARGET "${GPU_TARGET} sm_70" )
    endif()

    if (GPU_TARGET MATCHES Turing)
        set( GPU_TARGET "${GPU_TARGET} sm_75" )
    endif()

    if (GPU_TARGET MATCHES Ampere)
        set( GPU_TARGET "${GPU_TARGET} sm_80" )
    endif()

    if (GPU_TARGET MATCHES sm_20)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 200 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_20,code=sm_20 )
        set( NV_COMP        -gencode arch=compute_20,code=compute_20 )
        message( STATUS "    compile for CUDA arch 2.0 (Fermi)" )
    endif()

    if (GPU_TARGET MATCHES sm_30)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 300 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_30,code=sm_30 )
        set( NV_COMP        -gencode arch=compute_30,code=compute_30 )
        message( STATUS "    compile for CUDA arch 3.0 (Kepler)" )
    endif()

    if (GPU_TARGET MATCHES sm_35)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 300 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_35,code=sm_35 )
        set( NV_COMP        -gencode arch=compute_35,code=compute_35 )
        message( STATUS "    compile for CUDA arch 3.5 (Kepler)" )
    endif()

    if (GPU_TARGET MATCHES sm_37)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 300 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_37,code=sm_37 )
        set( NV_COMP        -gencode arch=compute_37,code=compute_37 )
        message( STATUS "    compile for CUDA arch 3.7 (Kepler)" )
    endif()

    if (GPU_TARGET MATCHES sm_50)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 500 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_50,code=sm_50 )
        set( NV_COMP        -gencode arch=compute_50,code=compute_50 )
        message( STATUS "    compile for CUDA arch 5.0 (Maxwell)" )
    endif()

    if (GPU_TARGET MATCHES sm_52)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 520 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_52,code=sm_52 )
        set( NV_COMP        -gencode arch=compute_52,code=compute_52 )
        message( STATUS "    compile for CUDA arch 5.2 (Maxwell)" )
    endif()

    if (GPU_TARGET MATCHES sm_53)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 530 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_53,code=sm_53 )
        set( NV_COMP        -gencode arch=compute_53,code=compute_53 )
        message( STATUS "    compile for CUDA arch 5.3 (Maxwell)" )
    endif()

    if (GPU_TARGET MATCHES sm_60)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 600 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_60,code=sm_60 )
        set( NV_COMP        -gencode arch=compute_60,code=compute_60 )
        message( STATUS "    compile for CUDA arch 6.0 (Pascal)" )
    endif()

    if (GPU_TARGET MATCHES sm_61)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 610 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_61,code=sm_61 )
        set( NV_COMP        -gencode arch=compute_61,code=compute_61 )
        message( STATUS "    compile for CUDA arch 6.1 (Pascal)" )
    endif()

    if (GPU_TARGET MATCHES sm_62)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 620 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_62,code=sm_62 )
        set( NV_COMP        -gencode arch=compute_62,code=compute_62 )
        message( STATUS "    compile for CUDA arch 6.2 (Pascal)" )
    endif()

    if (GPU_TARGET MATCHES sm_70)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 700 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_70,code=sm_70 )
        set( NV_COMP        -gencode arch=compute_70,code=compute_70 )
        message( STATUS "    compile for CUDA arch 7.0 (Volta)" )
    endif()

    if (GPU_TARGET MATCHES sm_71)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 710 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_71,code=sm_71 )
        set( NV_COMP        -gencode arch=compute_71,code=compute_71 )
        message( STATUS "    compile for CUDA arch 7.1 (Volta)" )
    endif()

    if (GPU_TARGET MATCHES sm_75)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 750 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_75,code=sm_75 )
        set( NV_COMP        -gencode arch=compute_75,code=compute_75 )
        message( STATUS "    compile for CUDA arch 7.5 (Turing)" )
    endif()

    if (GPU_TARGET MATCHES sm_80)
        if (NOT MIN_ARCH)
            set( MIN_ARCH 800 )
        endif()
        set( NV_SM ${NV_SM} -gencode arch=compute_80,code=sm_80 )
        set( NV_COMP        -gencode arch=compute_80,code=compute_80 )
        message( STATUS "    compile for CUDA arch 8.0 (Ampere)" )
    endif()

    if (NOT MIN_ARCH)
        message( FATAL_ERROR "GPU_TARGET must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]" )
    endif()

    set( CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} -Xcompiler -fPIC ${NV_SM} ${NV_COMP} ${FORTRAN_CONVENTION} )
    #add_definitions( "-DMAGMA_HAVE_CUDA -DMAGMA_CUDA_ARCH_MIN=${MIN_ARCH}" )
    set(MAGMA_HAVE_CUDA "1")
    set(MAGMA_CUDA_ARCH_MIN "${MIN_ARCH}")
    message( STATUS "Define -DMAGMA_HAVE_CUDA -DMAGMA_CUDA_ARCH_MIN=${MIN_ARCH}" )
  else()
    message( STATUS "Could not find CUDA" )
  endif()

endif()

if (MAGMA_ENABLE_HIP)
  set( GPU_TARGET "gfx900" CACHE STRING "HIP architectures to compile for" )
  list(APPEND CMAKE_PREFIX_PATH /opt/rocm/hip /opt/rocm)
  find_package( HIP )
  if (HIP_FOUND)
    message( STATUS "Found HIP ${HIP_VERSION}" )
    message( STATUS "    HIP_INCLUDE_DIRS:   ${HIP_INCLUDE_DIRS}"   )
    message( STATUS "GPU_TARGET:  ${GPU_TARGET}"   )

    include_directories( ${HIP_INCLUDE_DIRS} )

    set(HIP_SEPARABLE_COMPILATION ON)

    if (GPU_TARGET MATCHES kaveri)
      set( GPU_TARGET ${GPU_TARGET} gfx700 )
    endif()

    if (GPU_TARGET MATCHES hawaii)

=== Makefile ===
#--------------------------------------------------------------------
# build process
#
#



# ------------------------------------------------------------------------------
# programs
#
# Users should make all changes in make.inc
# It should not be necesary to change anything in here.

include make.inc

# --------------------
# configuration

# should MAGMA be built on CUDA (NVIDIA only) or HIP (AMD or NVIDIA)
# enter 'cuda' or 'hip' respectively
BACKEND     ?= cuda

# set these to their real paths
CUDADIR     ?= /usr/local/cuda
HIPDIR      ?= /opt/rocm/hip

# require either hip or cuda
ifeq (,$(findstring $(BACKEND),"hip cuda"))
    $(error "'BACKEND' should be either 'cuda' or 'hip' (got '$(BACKEND)')")
endif

# --------------------
# programs

# set compilers
CC          ?= gcc
CXX         ?= g++
FORT        ?= gfortran
HIPCC       ?= hipcc
NVCC        ?= nvcc
DEVCC       ?= NONE

# Configuration variables
HAVE_CUDA  =
HAVE_HIP   =
CUDA_ARCH_MIN =

# CMake.src file, which depends on the backend
CMAKESRC     = CMake.src.$(BACKEND)

# set from 'BACKEND'
ifeq ($(BACKEND),cuda)
    DEVCC = $(NVCC)
	HAVE_CUDA = 1

else ifeq ($(BACKEND),hip)
    DEVCC = $(HIPCC)
	HAVE_HIP = 1

    # if we are using HIP, make sure generated sources are up to date
    # Technically, this 'recursive' make which we don't like to do, but also this is a simple solution
    #   that allows that file to handle all code generation
    # Another reason is that I don't want to flood the namespace (for example, that file also
    #   defines an 'all' and 'clean' target as phonies)
    # So, in the future that whole file may be integrated, but for now this seems simplest
	# Detect number of jobs here, so it runs at an appropriate speed
    MAKE_PID := $(shell echo $$PPID)
    JOB_FLAG := $(filter -j%, $(subst -j ,-j,$(shell ps T | grep "^\s*$(MAKE_PID).*$(MAKE)")))
    JOBS     := $(subst -j,,$(JOB_FLAG))
    tmp := $(shell $(MAKE) -j$(JOBS) -f make.gen.hipMAGMA 1>&2)
else
    $(warning BACKEND: $(BACKEND) not recognized)
endif

# and utilities
ARCH        ?= ar
ARCHFLAGS   ?= cr
RANLIB      ?= ranlib


# --------------------
# flags/settings

# Use -fPIC to make shared (.so) and static (.a) library;
# can be commented out if making only static library.
FPIC        ?= -fPIC

# now, generate our flags
CFLAGS      ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -fopenmp -std=c99
CXXFLAGS    ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -fopenmp -std=c++11
FFLAGS      ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -Wno-unused-dummy-argument
F90FLAGS    ?= -O3 $(FPIC) -DNDEBUG -DADD_ -Wall -Wno-unused-dummy-argument -x f95-cpp-input
LDFLAGS     ?=     $(FPIC)                       -fopenmp

ifndef $(and DEVCCFLAGS, NVCCFLAGS)
    DEVCCFLAGS  ?= -O3         -DNDEBUG -DADD_
endif
# DEVCCFLAGS are populated later in `backend-specific`

# Extension for object files: o for unix, obj for Windows?
o_ext      ?= o

# where to install to?
prefix     ?= /usr/local/magma

# ------------------------------------------------------------------------------
# MAGMA-specific programs & flags

ifeq ($(blas_fix),1)
    # prepend -lblas_fix to LIB (it must come before LAPACK library/framework)
    LIB := -lblas_fix $(LIB)
endif

LIBS       = $(LIBDIR) $(LIB)

# preprocessor flags. See below for MAGMA_INC
CPPFLAGS   = $(INC) $(MAGMA_INC)

# where testers look for MAGMA libraries
RPATH      = -Wl,-rpath,${abspath ./lib}

codegen    = ./tools/codegen.py


ifeq ($(BACKEND),cuda)

	# Add legacy flags
	DEVCCFLAGS += $(NVCCFLAGS)

	# ------------------------------------------------------------------------------
	# NVCC options for the different cards
	# First, add smXX for architecture names
	# Internal CUDA architectures we support
	# TODO: Filter on regex to discard the named architectures?
	CUDA_ARCH_ := $(GPU_TARGET)
	ifneq ($(findstring Kepler, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_30
		CUDA_ARCH_ += sm_35
	endif
	ifneq ($(findstring Maxwell, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_50
	endif
	ifneq ($(findstring Pascal, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_60
	endif
	ifneq ($(findstring Volta, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_70
	endif
	ifneq ($(findstring Turing, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_75
	endif
	ifneq ($(findstring Ampere, $(GPU_TARGET)),)
		CUDA_ARCH_ += sm_80
	endif


	# Remember to add to CMakeLists.txt too!

	# Next, add compile options for specific smXX
	# sm_xx is binary, compute_xx is PTX for forward compatability
	# MIN_ARCH is lowest requested version
	#          Use it ONLY in magma_print_environment; elsewhere use __CUDA_ARCH__ or magma_getdevice_arch()
	# NV_SM    accumulates sm_xx for all requested versions
	# NV_COMP  is compute_xx for highest requested version
	#
	# See also $(info compile for ...) in Makefile


    CUDA_ARCH_UNKNOWN_ = $(filter-out sm_% Kepler Maxwell Pascal Volta Turing Ampere, $(CUDA_ARCH_))
    ifneq ($(CUDA_ARCH_UNKNOWN_),)
        $(error ERROR: unknown `$(CUDA_ARCH_UNKNOWN_)` in GPU_TARGET)
    endif

	# Now, sort sm's
    SMS      := $(patsubst sm_%,%,$(filter sm_%, $(CUDA_ARCH_)))
    SMS      := $(shell printf "%s\n" $(SMS) | sort -n)


    # code=sm_XX is binary, code=compute_XX is PTX
    GENCODE_SM      = -gencode arch=compute_$(sm),code=sm_$(sm)
    GENCODE_COMP    = -gencode arch=compute_$(sm),code=compute_$(sm)

    # Get gencode options for all sm_XX in cuda_arch_.
    NV_SM    := $(foreach sm,$(SMS),$(GENCODE_SM))
    NV_COMP  := $(foreach sm,$(SMS),$(GENCODE_COMP))

	# Check for empty
    ifeq ($(NV_SM),)
        $(error ERROR: unknown `GPU_TARGET=$(GPU_TARGET)`. Set cuda_arch to one or more of Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_XX from nvcc -h)
    else
        # Get last option (last 2 words) of nv_compute.
        nwords := $(words $(NV_COMP))
        nwords_1 := $(shell expr $(nwords) - 1)
        NV_COMP_LAST := $(wordlist $(nwords_1), $(nwords), $(NV_COMP))
    endif

    # Use all sm_XX (binary), and the last compute_XX (PTX) for forward compatibility.
    DEVCCFLAGS += $(NV_SM) $(NV_COMP_LAST)
    LIBS += -lcublas -lcudart

    # Get first (minimum) architecture
	# (add zero, so its comparable to '__CUDA_ARCH__')
    CUDA_ARCH_MIN := $(word 1, $(SMS))0
    ifeq ($(CUDA_ARCH_MIN),)
        $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, or valid sm_[0-9][0-9]. Please edit your make.inc file)
    endif
else ifeq ($(BACKEND),hip)

	# ------------------------------------------------------------------------------
	# hipcc backend
	# Source: https://llvm.org/docs/AMDGPUUsage.html#target-triples

	# Filter our human readable names and replace with numeric names
    HIP_ARCH_ := $(GPU_TARGET)
	ifneq ($(findstring kaveri, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx700
	endif
	ifneq ($(findstring hawaii, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx701
	endif
	ifneq ($(findstring kabini, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx703
	endif
	ifneq ($(findstring mullins, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx703
	endif
	ifneq ($(findstring bonaire, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx704
	endif
	ifneq ($(findstring carrizo, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx801
	endif
	ifneq ($(findstring iceland, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx802
	endif
	ifneq ($(findstring tonga, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx802
	endif
	ifneq ($(findstring fiji, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx803
	endif
	# These are in the documentation, and the leftmost column *seems* like a continuation
	#   of gfx803
	ifneq ($(findstring polaris10, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx803
	endif
	ifneq ($(findstring polaris11, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx803
	endif

	ifneq ($(findstring tongapro, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx805
	endif
	ifneq ($(findstring stoney, $(GPU_TARGET)),)
		HIP_ARCH_ += gfx810
	endif

    ## Suggestion by Mark (from SLATE)
    # Valid architecture numbers
    # TODO: remove veryold ones?
    VALID_GFXS = 600 601 602 700 701 702 703 704 705 801 802 803 805 810 900 902 904 906 908 909 90a 90c 1010 1011 1012 1030 1031 1032 1033


	# Generated GFX option
    TARGET_GFX      = --amdgpu-target=gfx$(gfx)

    # Get gencode options for all sm_XX in cuda_arch_.
    AMD_GFX    := $(filter %, $(foreach gfx, $(VALID_GFXS),$(if $(findstring gfx$(gfx), $(HIP_ARCH_)),$(TARGET_GFX))))

    ifeq ($(AMD_GFX),)
        $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of the targets for AMDGPUs (https://llvm.org/docs/AMDGPUUsage.html#target-triples), or valid gfx[0-9][0-9][0-9][0-9]?. Please edit your make.inc file)
    else
    endif

    # Use all sm_XX (binary), and the last compute_XX (PTX) for forward compatibility.
    DEVCCFLAGS += $(AMD_GFX)

    # Get first (minimum) architecture
	# NOTE: Not so useful for HIP
    #MIN_ARCH := $(wordlist 1, 1, $(foreach gfx, $(VALID_GFXS),$(if $(findstring gfx$(gfx), $(HIP_ARCH_)),$(gfx))))
	#ifeq ($(MIN_ARCH),)
	#	$(error GPU_TARGET, currently $(GPU_TARGET), did not contain a minimum arch)
	#endif

endif


# ------------------------------------------------------------------------------
# Define the pointer size for fortran compilation
# If there's an issue compiling sizeptr, assume 8 byte (64 bit) pointers
PTRFILE = control/sizeptr.c
PTROBJ  = control/sizeptr.$(o_ext)
PTREXEC = control/sizeptr
PTRSIZE = $(shell if [ -x $(PTREXEC) ]; then $(PTREXEC); else echo 8; fi)
PTROPT  = -Dmagma_devptr_t="integer(kind=$(PTRSIZE))"

$(PTREXEC): $(PTROBJ)
	-$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $<
	touch $@

$(PTROBJ): $(PTRFILE)
	-$(CC) $(CFLAGS) -c -o $@ $<
	touch $@


# ------------------------------------------------------------------------------
# include sub-directories

# variables that multiple sub-directories add to.
# these MUST be := defined, not = defined, for $(cdir) to work.
hdr                  :=
libmagma_src         :=
libmagma_dynamic_src :=
testing_src          :=
libsparse_src        :=
libsparse_dynamic_src:=
sparse_testing_src   :=

subdirs := \
	blas_fix            \
	control             \
	include             \
	src                 \
	testing/lin         \

# the directory in which the MAGMA sparse source is located
# change to sparse_hip for hipified sources
# right now, just use old one so the dense section still builds

ifeq ($(BACKEND),cuda)
	SPARSE_DIR ?= sparse
	subdirs += interface_cuda
	subdirs += testing
	subdirs += magmablas

    # add all sparse folders
	# Don't do it for HIP yet
    subdirs += $(SPARSE_DIR) $(SPARSE_DIR)/blas $(SPARSE_DIR)/control $(SPARSE_DIR)/include $(SPARSE_DIR)/src $(SPARSE_DIR)/testing

else ifeq ($(BACKEND),hip)
	SPARSE_DIR ?= ./sparse_hip
	subdirs += interface_hip
	subdirs += magmablas_hip
	subdirs += testing

    subdirs += $(SPARSE_DIR) $(SPARSE_DIR)/blas $(SPARSE_DIR)/control $(SPARSE_DIR)/include $(SPARSE_DIR)/src $(SPARSE_DIR)/testing

endif




Makefiles := $(addsuffix /Makefile.src, $(subdirs))

#$(info $$Makefiles=$(Makefiles))

include $(Makefiles)

-include Makefile.internal
-include Makefile.local
-include Makefile.gen.$(BACKEND)

#$(info $$libmagma_src=$(libmagma_src))
#$(info $$libmagma_all=$(libmagma_all))

# ------------------------------------------------------------------------------
# objects

ifeq ($(FORT),)
    liblapacktest_all2 := $(filter     %_no_fortran.cpp, $(liblapacktest_all))
else
    liblapacktest_all2 := $(filter-out %_no_fortran.cpp, $(liblapacktest_all))
endif

ifeq ($(FORT),)
    libmagma_all := $(filter-out %.f %.f90 %.F90, $(libmagma_all))
    testing_all  := $(filter-out %.f %.f90 %.F90, $(testing_all))
endif

libmagma_obj       := $(addsuffix .$(o_ext), $(basename $(libmagma_all)))
libblas_fix_obj    := $(addsuffix .$(o_ext), $(basename $(libblas_fix_src)))
libtest_obj        := $(addsuffix .$(o_ext), $(basename $(libtest_all)))
liblapacktest_obj  := $(addsuffix .$(o_ext), $(basename $(liblapacktest_all2)))
testing_obj        := $(addsuffix .$(o_ext), $(basename $(testing_all)))
libsparse_obj      := $(addsuffix .$(o_ext), $(basename $(libsparse_all)))

=== example/Makefile ===
# This is a simple standalone example. See README.txt
# Initially it is setup to use OpenBLAS.
# See magma/make.inc for alternate BLAS and LAPACK libraries,
# or use pkg-config as described below.

# Paths where MAGMA, CUDA, and OpenBLAS are installed.
# MAGMADIR can be .. to test without installing.
#MAGMADIR     ?= ..
MAGMADIR     ?= /usr/local/magma
CUDADIR      ?= /usr/local/cuda
OPENBLASDIR  ?= /usr/local/openblas

CC            = gcc
FORT          = gfortran
LD            = gcc
CFLAGS        = -Wall
# needs -fopenmp if MAGMA was compiled with OpenMP
LDFLAGS       = -Wall #-fopenmp


# ----------------------------------------
# Flags and paths to MAGMA, CUDA, and LAPACK/BLAS
# MAGMA_CFLAGS     := -DADD_ \
#                     -I$(MAGMADIR)/include \
#                     -I$(MAGMADIR)/sparse/include \
#                     -I$(CUDADIR)/include
# 
# MAGMA_F90FLAGS   := -Dmagma_devptr_t="integer(kind=8)" \
#                     -I$(MAGMADIR)/include
# 
# # may be lib instead of lib64 on some systems
# MAGMA_LIBS       := -L$(MAGMADIR)/lib -lmagma_sparse -lmagma \
#                     -L$(CUDADIR)/lib64 -lcublas -lcudart -lcusparse \
#                     -L$(OPENBLASDIR)/lib -lopenblas


# ----------------------------------------
# Alternatively, using pkg-config (see README.txt):
MAGMA_CFLAGS   := $(shell pkg-config --cflags magma)

MAGMA_F90FLAGS := -Dmagma_devptr_t="integer(kind=8)" \
                  $(shell pkg-config --cflags-only-I magma)

MAGMA_LIBS     := $(shell pkg-config --libs   magma)


# ----------------------------------------
default:
	@echo "Available make targets are:"
	@echo "  make all       # compiles example_v1, example_v2, example_sparse, example_sparse_operator, and example_f"
	@echo "  make c         # compiles example_v1, example_v2, example_sparse, example_sparse_operator"
	@echo "  make fortran   # compiles example_f"
	@echo "  make clean     # deletes executables and object files"

all: c fortran

c: example_v1 example_v2 example_sparse example_sparse_operator

fortran: example_f

clean:
	-rm -f example_v1 example_v2 example_sparse example_sparse_operator example_f *.o *.mod

.SUFFIXES:


# ----------------------------------------
# C example
%.o: %.c
	$(CC) $(CFLAGS) $(MAGMA_CFLAGS) -c -o $@ $<

example_v1: example_v1.o
	$(LD) $(LDFLAGS) -o $@ $^ $(MAGMA_LIBS)

example_v2: example_v2.o
	$(LD) $(LDFLAGS) -o $@ $^ $(MAGMA_LIBS)

example_sparse: example_sparse.o
	$(LD) $(LDFLAGS) -o $@ $^ $(MAGMA_LIBS)
	
example_sparse_operator: example_sparse_operator.o
	$(LD) $(LDFLAGS) -o $@ $^ $(MAGMA_LIBS)


# ----------------------------------------
# Fortran example
# this uses capital .F90 to preprocess to define magma_devptr_t
%.o: %.F90
	$(FORT) $(F90FLAGS) $(MAGMA_F90FLAGS) -c -o $@ $<

example_f: example_f.o
	$(FORT) $(LDFLAGS) -o $@ $^ $(MAGMA_LIBS)

=== debian/changelog ===
magma (2.6.2-1build1) mantic; urgency=medium

  * No-change rebuild against libcublas12

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 05 Jul 2023 21:17:36 +0000

magma (2.6.2-1) unstable; urgency=medium

  * New upstream version 2.6.2
  * Refresh and rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Thu, 24 Mar 2022 11:45:02 -0400

=== debian/control ===
Source: magma
Section: contrib/math
Homepage: https://icl.cs.utk.edu/magma/
Priority: optional
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/science-team/magma.git
Vcs-Browser: https://salsa.debian.org/science-team/magma
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: debhelper-compat (= 12),
               gfortran,
               libopenblas-dev,
               nvidia-cuda-toolkit-gcc,
Build-Depends-Indep: doxygen

Package: libmagma2
Section: contrib/libs
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (solib)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the shared object libmagma.so.2

Package: libmagma-sparse2
Section: contrib/libs
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (solib, sparse)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the shared object libmagma_sparse.so.2

Package: libmagma-dev
Section: contrib/libdevel
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
 libmagma2 (= ${binary:Version}), libmagma-sparse2 (= ${binary:Version}),
Description: Matrix Algebra on GPU and Multicore Architectures (dev)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the headers and the static libraries.

Package: libmagma-test
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (tests)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the test executables.

Package: libmagma-doc
Section: contrib/doc
Architecture: all
Depends: ${misc:Depends}
Description: Matrix Algebra on GPU and Multicore Architectures (doc)
 The MAGMA project aims to develop a dense linear algebra library similar to
 LAPACK but for heterogeneous/hybrid architectures, starting with current
 "Multicore+GPU" systems.
 .
 The MAGMA research is based on the idea that, to address the complex challenges
 of the emerging hybrid environments, optimal software solutions will themselves
 have to hybridize, combining the strengths of different algorithms within a
 single framework. Building on this idea, we aim to design linear algebra
 algorithms and frameworks for hybrid manycore and GPU systems that can enable
 applications to fully exploit the power that each of the hybrid components
 offers.
 .
 This package contains the Doxygen HTML documentation.

## magma 2.7.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required( VERSION 2.8.1 )
+cmake_minimum_required( VERSION 3.18 )
 
 # ----------------------------------------
 # to disable Fortran, set this to "off"
@@ -67,6 +67,7 @@
 include(CheckCCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
+CHECK_CXX_COMPILER_FLAG("-fPIC" COMPILER_SUPPORTS_FPIC)
 if (COMPILER_SUPPORTS_CXX11)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 elseif(COMPILER_SUPPORTS_CXX0X)
@@ -112,33 +113,32 @@
 endif()
 
 if (MAGMA_ENABLE_CUDA)
+  enable_language(CUDA)
+
   # ----------------------------------------
   # locate CUDA libraries
-  set( GPU_TARGET "Kepler Maxwell Pascal" CACHE STRING "CUDA architectures to compile for; one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]" )
-  find_package( CUDA )
-  if (CUDA_FOUND)
+  set( GPU_TARGET "Kepler Maxwell Pascal" CACHE STRING "CUDA architectures to compile for; one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, Hopper, or valid sm_[0-9][0-9]" )
+  find_package( CUDAToolkit )
+  if (CUDAToolkit_FOUND)
     message( STATUS "Found CUDA ${CUDA_VERSION}" )
-    message( STATUS "    CUDA_INCLUDE_DIRS:   ${CUDA_INCLUDE_DIRS}"   )
-    message( STATUS "    CUDA_CUDART_LIBRARY: ${CUDA_CUDART_LIBRARY}" )
-    #message( STATUS "    CUDA_LIBRARIES: ${CUDA_LIBRARIES}" )
-    #message( STATUS "    CUDA_CUBLAS_LIBRARIES: ${CUDA_CUBLAS_LIBRARIES}" )
-    include_directories( ${CUDA_INCLUDE_DIRS} )
+    message( STATUS "    CUDA_CUDART_LIBRARY: CUDA::cudart" )
+    #message( STATUS "    CUDA_CUBLAS_LIBRARIES: CUDA::cublas" )
 
     # NVCC options for the different cards
     # sm_xx is binary, compute_xx is PTX for forward compatability
     # MIN_ARCH is lowest requested version
-    # NV_SM    accumulates sm_xx for all requested versions
-    # NV_COMP  is compute_xx for highest requested version
-    set( NV_SM    "" )
-    set( NV_COMP  "" )
-
-    set(CUDA_SEPARABLE_COMPILATION ON)
-
-    # nvcc >= 6.5 supports -std=c++11, so propagate CXXFLAGS to NVCCFLAGS.
-    # Older nvcc didn't support -std=c++11, so previously we disabled propagation.
-    ##if (${CMAKE_CXX_FLAGS} MATCHES -std=)
-    ##    set( CUDA_PROPAGATE_HOST_FLAGS OFF )
-    ##endif()
+
+    if(WIN32)
+        # Disable separable compilation on Windows because object linking list
+        # becomes too long when building multiple archs and MSVC throws errors
+        set(CUDA_SEPARABLE_COMPILATION OFF)
+    else()
+        set(CUDA_SEPARABLE_COMPILATION ON)
+    endif()
+
+    set(__cuda_architectures)
+
+    include_directories( ${CUDAToolkit_INCLUDE_DIRS} )
 
     if (GPU_TARGET MATCHES Fermi)
         set( GPU_TARGET "${GPU_TARGET} sm_20" )
@@ -168,12 +168,15 @@
         set( GPU_TARGET "${GPU_TARGET} sm_80" )
     endif()
 
+    if (GPU_TARGET MATCHES Hopper)
+        set( GPU_TARGET "${GPU_TARGET} sm_90" )
+    endif()
+
     if (GPU_TARGET MATCHES sm_20)
         if (NOT MIN_ARCH)
             set( MIN_ARCH 200 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_20,code=sm_20 )
-        set( NV_COMP        -gencode arch=compute_20,code=compute_20 )
+        list(APPEND __cuda_architectures 20)
         message( STATUS "    compile for CUDA arch 2.0 (Fermi)" )
     endif()
 
@@ -181,8 +184,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 300 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_30,code=sm_30 )
-        set( NV_COMP        -gencode arch=compute_30,code=compute_30 )
+        list(APPEND __cuda_architectures 30)
         message( STATUS "    compile for CUDA arch 3.0 (Kepler)" )
     endif()
 
@@ -190,8 +192,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 300 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_35,code=sm_35 )
-        set( NV_COMP        -gencode arch=compute_35,code=compute_35 )
+        list(APPEND __cuda_architectures 35)
         message( STATUS "    compile for CUDA arch 3.5 (Kepler)" )
     endif()
 
@@ -199,8 +200,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 300 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_37,code=sm_37 )
-        set( NV_COMP        -gencode arch=compute_37,code=compute_37 )
+        list(APPEND __cuda_architectures 37)
         message( STATUS "    compile for CUDA arch 3.7 (Kepler)" )
     endif()
 
@@ -208,8 +208,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 500 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_50,code=sm_50 )
-        set( NV_COMP        -gencode arch=compute_50,code=compute_50 )
+        list(APPEND __cuda_architectures 50)
         message( STATUS "    compile for CUDA arch 5.0 (Maxwell)" )
     endif()
 
@@ -217,8 +216,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 520 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_52,code=sm_52 )
-        set( NV_COMP        -gencode arch=compute_52,code=compute_52 )
+        list(APPEND __cuda_architectures 52)
         message( STATUS "    compile for CUDA arch 5.2 (Maxwell)" )
     endif()
 
@@ -226,8 +224,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 530 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_53,code=sm_53 )
-        set( NV_COMP        -gencode arch=compute_53,code=compute_53 )
+        list(APPEND __cuda_architectures 53)
         message( STATUS "    compile for CUDA arch 5.3 (Maxwell)" )
     endif()
 
@@ -235,8 +232,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 600 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_60,code=sm_60 )
-        set( NV_COMP        -gencode arch=compute_60,code=compute_60 )
+        list(APPEND __cuda_architectures 60)
         message( STATUS "    compile for CUDA arch 6.0 (Pascal)" )
     endif()
 
@@ -244,8 +240,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 610 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_61,code=sm_61 )
-        set( NV_COMP        -gencode arch=compute_61,code=compute_61 )
+        list(APPEND __cuda_architectures 61)
         message( STATUS "    compile for CUDA arch 6.1 (Pascal)" )
     endif()
 
@@ -253,8 +248,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 620 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_62,code=sm_62 )
-        set( NV_COMP        -gencode arch=compute_62,code=compute_62 )
+        list(APPEND __cuda_architectures 62)
         message( STATUS "    compile for CUDA arch 6.2 (Pascal)" )
     endif()
 
@@ -262,8 +256,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 700 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_70,code=sm_70 )
-        set( NV_COMP        -gencode arch=compute_70,code=compute_70 )
+        list(APPEND __cuda_architectures 70)
         message( STATUS "    compile for CUDA arch 7.0 (Volta)" )
     endif()
 
@@ -271,8 +264,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 710 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_71,code=sm_71 )
-        set( NV_COMP        -gencode arch=compute_71,code=compute_71 )
+        list(APPEND __cuda_architectures 71)
         message( STATUS "    compile for CUDA arch 7.1 (Volta)" )
     endif()
 
@@ -280,8 +272,7 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 750 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_75,code=sm_75 )
-        set( NV_COMP        -gencode arch=compute_75,code=compute_75 )
+        list(APPEND __cuda_architectures 75)
         message( STATUS "    compile for CUDA arch 7.5 (Turing)" )
     endif()
 
@@ -289,17 +280,38 @@
         if (NOT MIN_ARCH)
             set( MIN_ARCH 800 )
         endif()
-        set( NV_SM ${NV_SM} -gencode arch=compute_80,code=sm_80 )
-        set( NV_COMP        -gencode arch=compute_80,code=compute_80 )
+        list(APPEND __cuda_architectures 80)
         message( STATUS "    compile for CUDA arch 8.0 (Ampere)" )
+    endif()
+
+    if (GPU_TARGET MATCHES sm_90)
+        if (NOT MIN_ARCH)
+            set( MIN_ARCH 900 )
+        endif()
+        list(APPEND __cuda_architectures 90)
+        message( STATUS "    compile for CUDA arch 9.0 (Hopper)" )
     endif()
 
     if (NOT MIN_ARCH)
         message( FATAL_ERROR "GPU_TARGET must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_[0-9][0-9]" )
     endif()
 
-    set( CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS} -Xcompiler -fPIC ${NV_SM} ${NV_COMP} ${FORTRAN_CONVENTION} )
-    #add_definitions( "-DMAGMA_HAVE_CUDA -DMAGMA_CUDA_ARCH_MIN=${MIN_ARCH}" )
+    set(CUDA_ARCHITECTURES "${__cuda_architectures}")
+
+    add_library(magma_nvcc_flags INTERFACE)
+    if (COMPILER_SUPPORTS_FPIC)
+        target_compile_options(magma_nvcc_flags
+            INTERFACE
+            $<$<COMPILE_LANGUAGE:CUDA>:--compiler-options;-fPIC,${FORTRAN_CONVENTION}>
+        )
+    else()
+        # No Position Independent Code on Windows. Compiler will complain if you add that flag.
+        target_compile_options(magma_nvcc_flags
+            INTERFACE
+            $<$<COMPILE_LANGUAGE:CUDA>:--compiler-options;${FORTRAN_CONVENTION}>
+        )
+    endif(COMPILER_SUPPORTS_FPIC)
+
     set(MAGMA_HAVE_CUDA "1")
     set(MAGMA_CUDA_ARCH_MIN "${MIN_ARCH}")
     message( STATUS "Define -DMAGMA_HAVE_CUDA -DMAGMA_CUDA_ARCH_MIN=${MIN_ARCH}" )
@@ -311,7 +323,7 @@
 
 if (MAGMA_ENABLE_HIP)
   set( GPU_TARGET "gfx900" CACHE STRING "HIP architectures to compile for" )
-  list(APPEND CMAKE_PREFIX_PATH /opt/rocm/hip /opt/rocm)
+  list(APPEND CMAKE_PREFIX_PATH /opt/rocm /opt/rocm/hip)
   find_package( HIP )
   if (HIP_FOUND)
     message( STATUS "Found HIP ${HIP_VERSION}" )
@@ -327,3 +339,35 @@
     endif()
 
     if (GPU_TARGET MATCHES hawaii)
+      set( GPU_TARGET ${GPU_TARGET} gfx701 )
+    endif()
+
+    if (GPU_TARGET MATCHES kabini)
+      set( GPU_TARGET ${GPU_TARGET} gfx703 )
+    endif()
+
+    if (GPU_TARGET MATCHES mullins)
+      set( GPU_TARGET ${GPU_TARGET} gfx703 )
+    endif()
+
+    if (GPU_TARGET MATCHES bonaire)
+      set( GPU_TARGET ${GPU_TARGET} gfx704 )
+    endif()
+
+    if (GPU_TARGET MATCHES carrizo)
+      set( GPU_TARGET ${GPU_TARGET} gfx801 )
+    endif()
+
+    if (GPU_TARGET MATCHES iceland)
+      set( GPU_TARGET ${GPU_TARGET} gfx802 )
+    endif()
+
+    if (GPU_TARGET MATCHES tonga)
+      set( GPU_TARGET ${GPU_TARGET} gfx802 )
+    endif()
+
+    if (GPU_TARGET MATCHES fiji)
+      set( GPU_TARGET ${GPU_TARGET} gfx803 )
+    endif()
+
+    if (GPU_TARGET MATCHES polaris10)

=== Makefile ===
--- 
+++ 
@@ -152,6 +152,9 @@
 	ifneq ($(findstring Ampere, $(GPU_TARGET)),)
 		CUDA_ARCH_ += sm_80
 	endif
+	ifneq ($(findstring Hopper, $(GPU_TARGET)),)
+		CUDA_ARCH_ += sm_90
+	endif
 
 
 	# Remember to add to CMakeLists.txt too!
@@ -166,7 +169,7 @@
 	# See also $(info compile for ...) in Makefile
 
 
-    CUDA_ARCH_UNKNOWN_ = $(filter-out sm_% Kepler Maxwell Pascal Volta Turing Ampere, $(CUDA_ARCH_))
+    CUDA_ARCH_UNKNOWN_ = $(filter-out sm_% Kepler Maxwell Pascal Volta Turing Ampere Hopper, $(CUDA_ARCH_))
     ifneq ($(CUDA_ARCH_UNKNOWN_),)
         $(error ERROR: unknown `$(CUDA_ARCH_UNKNOWN_)` in GPU_TARGET)
     endif
@@ -186,7 +189,7 @@
 
 	# Check for empty
     ifeq ($(NV_SM),)
-        $(error ERROR: unknown `GPU_TARGET=$(GPU_TARGET)`. Set cuda_arch to one or more of Kepler, Maxwell, Pascal, Volta, Turing, Ampere, or valid sm_XX from nvcc -h)
+        $(error ERROR: unknown `GPU_TARGET=$(GPU_TARGET)`. Set cuda_arch to one or more of Kepler, Maxwell, Pascal, Volta, Turing, Ampere, Hopper, or valid sm_XX from nvcc -h)
     else
         # Get last option (last 2 words) of nv_compute.
         nwords := $(words $(NV_COMP))
@@ -202,7 +205,7 @@
 	# (add zero, so its comparable to '__CUDA_ARCH__')
     CUDA_ARCH_MIN := $(word 1, $(SMS))0
     ifeq ($(CUDA_ARCH_MIN),)
-        $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, or valid sm_[0-9][0-9]. Please edit your make.inc file)
+        $(error GPU_TARGET, currently $(GPU_TARGET), must contain one or more of Fermi, Kepler, Maxwell, Pascal, Volta, Turing, Ampere, Hopper, or valid sm_[0-9][0-9]. Please edit your make.inc file)
     endif
 else ifeq ($(BACKEND),hip)
 
@@ -382,4 +385,3 @@
 libtest_obj        := $(addsuffix .$(o_ext), $(basename $(libtest_all)))
 liblapacktest_obj  := $(addsuffix .$(o_ext), $(basename $(liblapacktest_all2)))
 testing_obj        := $(addsuffix .$(o_ext), $(basename $(testing_all)))
-libsparse_obj      := $(addsuffix .$(o_ext), $(basename $(libsparse_all)))

=== sparse_hip/control/Makefile ===
# See Makefile.src for list of files in this directory.
# This makefile simply forwards commands to the top-level makefile.

top  := ../..
pwd  := $(shell pwd)
cdir := sparse_hip/control

default: $(cdir)

include $(top)/Makefile.subdir

=== debian/changelog ===
magma (2.7.2+ds-1) unstable; urgency=medium

  * New upstream version 2.7.2+ds (Closes: #1036679)
  * watch: Update upstream download page link.
  * Rebase existing patches.
  * Fix the superfluous file patterns in d/copyright.

 -- Mo Zhou <lumin@debian.org>  Wed, 06 Sep 2023 21:01:52 -0400

magma (2.7.0+ds-1) unstable; urgency=medium

  * New upstream version 2.7.0+ds
  * Refresh existing patches. Deprecate gpu-target.patch

 -- Mo Zhou <lumin@debian.org>  Thu, 15 Dec 2022 18:22:36 -0500
